import java.io.*;
import java.util.*;

public class MaartenScanner {
    public static void main(String[] args) throws IOException {
        try (BufferedReader reader = new BufferedReader(new InputStreamReader(System.in))) {
            new MaartenScanner().run(new Scanner(reader));
        }
    }

    public void run(Scanner sc) throws IOException {
        int n = sc.nextInt(), k = sc.nextInt();

        int[][] sums = new int[n][2];
        for (int i = 0; i < n; i++) {
            sums[i][0] = i;
        }

        for (int i = 0; i < k; i++) {
            for (int j = 0; j < n; j++) {
                sums[sc.nextInt() - 1][1] += j;
            }
        }

        Arrays.sort(sums, Comparator.comparingInt(pair -> pair[1]));

        for (int i = 0; i < n; i++) {
            System.out.println(sums[i][0] + 1);
        }
    }
}
