import java.util.ArrayList;
import java.util.Scanner;

class Point {
	public Point(int x, int y) {
		this.x = x;
		this.y = y;
	}

	int x;
	int y;
}

public class NickyEnMark {
	public static void main(String[] args) {
		Scanner scanner = new Scanner(System.in);
		int k = scanner.nextInt();
		ArrayList<Point> points = new ArrayList<>();
		for (int i = 0; i < k; i++) {
			int x = scanner.nextInt();
			int y = scanner.nextInt();
			points.add(new Point(x, y));
		}

		double best = 100000000;

		for (int i = 0; i < k; i++) {
			double totalDist = 0;
			for (int j = 0; j < k; j++) {
				totalDist += Math.sqrt(
						(points.get(i).x - points.get(j).x) * (points.get(i).x - points.get(j).x)
								+
								(points.get(i).y - points.get(j).y) * (points.get(i).y - points.get(j).y)
				);
			}

			if (totalDist < best) {
				best = totalDist;
			}
		}

		System.out.println(best / (k - 1));
	}
}
