#include <iostream>
#include <cmath>

using namespace std;

const int N = 1050;

int n;
int x[N];
int y[N];

int main() {
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> x[i] >> y[i];
    }

    double dist = 1e100;
    for (int i = 0; i < n; ++i) {
        double total = 0;
        for (int j = 0; j < n; ++j) {
            int dx = x[i] - x[j];
            int dy = y[i] - y[j];
            total += sqrt(dx * dx + dy * dy);
        }
        dist = min(dist, total);
    }

    cout.precision(10);
    cout << dist / (n-1) << endl;
    return 0;
}
