#! /usr/bin/env python3

import sys
import math

n = int(sys.stdin.readline())
cities = []
for line in sys.stdin:
    x, y = [int(v) for v in line.split()]
    cities.append((x, y))

dist = 1e100
for sx, sy in cities:
    total = 0
    for fx, fy in cities:
        dx = fx - sx
        dy = fy - sy
        total += math.sqrt(dx * dx + dy * dy)
    dist = min(dist, total)

print('{:.10f}'.format(dist / (n-1)))
