import kotlin.math.pow
import kotlin.math.sqrt

fun main() {
    val k = readln().toInt()
    val coordinates = System.`in`.bufferedReader().lineSequence().take(k)
        .map { line -> line.split(" ").map { it.toInt() }.zipWithNext().first() }.toList()
    coordinates.minOf { coordinate ->
        coordinates.filter { it != coordinate }
            .map { distance(coordinate.first, it.first, coordinate.second, it.second) }.average()
    }.also { println(it) }
}

fun distance(x1: Int, x2: Int, y1: Int, y2: Int) =
    sqrt((x1.toDouble() - x2.toDouble()).pow(2) + (y1.toDouble() - y2.toDouble()).pow(2))