#!/usr/bin/env python3
h, w = map(int, input().split())
b = [input() for _ in range(h)]


def rotate():
    global h, w, b
    b = ["".join(b[i][w - 1 - j] for i in range(h)) for j in range(w)]
    h, w = w, h


def test():
    for j in range(w):
        saw_dot = False
        for i in range(h):
            if b[i][j] == ".":
                saw_dot = True
            else:
                if saw_dot:
                    return False
    return True


def invert():
    for i in range(h):
        b[i] = "".join("#" if c == "." else "." for c in b[i])


for i in range(4):
    if not test():
        rotate()
        continue

    print(h, w)
    invert()
    for r in b:
        print(r)
    exit()
print("impossible")
